unit delgraph;
interface
uses Graphics,Classes,winProcs,extCtrls;
{ DELGRAPH V0.75 Beta
 (Copyright) MATHEsoft 2000-2004
  This is a beta-version and not complete support of TurboPascal Unit graph.tpu
  But this unit gives the basis for simple Pascal graphics.
  Use this unit like Turbo Pascal.

  Initgraph(Canvas-Object, maximal X , maximal Y);

  Example:
  Put a TImage-Object named Surface on your Form.
  write in TForm.OnCreate this:
   with Surface do Initgraph(Canvas, width, height);
   randomize;
  Now it is ready to paint. Put a TTimer and in OnTimer write this:
   putpixel(random(maxx),random(maxy),random(15)+1);
  The example fill the TImage-Object with colored dots

  This Unit is free to use.
  Please look for new stuff at http://www.mathesoft.de
  and tell me any errors.

  History:
  0.72 there was a simple but devil bug ...
  0.75 more functions, less bugs. You not need to CloseGraph at the end.

  Last update: 23.Feb.2004
}
const Detect=0;
      VGAHi=2;
      EGA64=4;
      MaxColors = 15;
      MaxX:word=320;
      MaxY:word=200;
      GDriver:byte=Detect;

      NormalPut=0;
      CopyPut=0;
      XORPut=1;
      OrPut=2;
      AndPut=3;
      NotPut=4;

      UserCharSet:byte=DEFAULT_CHARSET;
      VGAactive:boolean=false;
      black=0; blue=1; green=2; cyan=3;
      red=4; magenta=5; brown=6; lightgray=7;
      darkgray=8; lightblue=9; lightgreen=10; lightcyan=11;
      lightred=12; lightmagenta=13; yellow=14; white=15;

type
     ArcCoordsType = record
     x,y,Xstart,yStart,Xend,Yend:integer;
     end;
     FillPatternType = array[1..8] of Byte;
     FillSettingsType = record
      Pattern:word;
      Color:longint;
     end;
     FontNameType = array[0..5] of shortstring; //extra
     LineSettingsType = record
      LineStyle,Pattern,Thickness:word;
     end;

     PaletteType = record
      Size:byte;
      Colors:array[0..MaxColors] of longint;
     end;

     PointType = record x,y:integer; end;

     TextSettingsType = record
      Font,Direction,Charsize,Horiz,Vert:word;
     end;

     ViewPortType = record
      x1,y1,x2,y2:integer;
      Clip:boolean;
     end;

const
      ClipOn=true;
      ClipOff=false;

      TopOn=true;
      TopOff=false;

      EmptyFill = 0;
      SolidFill = 1;
      LineFill = 2;
      LtSlashFill = 3;
      SlashFill = 4;
      BkSlashFill =5;
      LtBkSlashFill=6;
      HatchFill=7;
      XHatchFill=8;
      InterleaveFill=9;
      WideDotFill=10;
      CloseDotFill=11;
      UserFill=12;

      SolidLn=0;
      DottedLn=1;
      CenterLn=2;
      DashedLn=3;
      UserBitLn=4;
      NormWidth=1;
      Thickwidth=3;

      DefaultFont=0;
      TriplexFont=1;
      SmallFont=2;
      SansSerifFont=3;
      GothicFont=4;
      HorizDir=0;
      VertDir=1;
      UserCharSize=0;

      LeftText=0;
      CenterText=1;
      RightText=2;
      BottomText=0;
      //CenterText=1;
      TopText=2;

var MyScreen:TCanvas;
    FontNames:FontNameType;
    GRaphFreeMemPtr:pointer;
    GraphGetMemPtr:pointer;
    vFillSettings:FillSettingsType;
    ColorTable,Palette:PaletteType;

procedure Arc(x,y:Integer;StAngle,EndAngle,Radius:word);
procedure Bar(x1,y1,x2,y2:integer);
procedure ClearDevice;
procedure ClearViewPort;
procedure CloseGraph;
procedure Circle(x,y:integer;Radius:word);
procedure DetectGraph(var GDriver,GMode:Integer);
procedure DrawPoly(NumPoints:word; var PolyPoints);
procedure Ellipse(x,y:integer; StAngle,EndAngle, XRadius,YRadius:word);
procedure FillEllipse(x,y:integer; XRadius,YRadius:Word);
procedure FillPoly(NumPoints:Word; var PolyPoints);
procedure FloodFill(x,y:Integer; BorderColor:longint);
procedure GetArcCoords(var ArcCoords: ArcCoordsType);
procedure GetAspectRatio(var Xasp,Yasp:word);
function  GetBkColor:longint;
function  GetColor:longint;
procedure GetDefaultpalette(var Palette:PaletteType);
function  GetDriverName:shortstring;
function  GetEGAColor(Pixel:longint):longint;
function  GetVGAColor(EGACol:byte):longint;
procedure GetFillPattern(var FillPattern:FillPatternType);
procedure GetFillSettings(var FillInfo:FillSettingsType);
function  GetGraphMode:Integer;
procedure GetImage(x1,y1,x2,y2:Integer; var pBitMap);
procedure GetLineSettings(var LineInfo:LineSettingsType);
function  GetMaxColor:longint;
function  GetMaxMode:Integer;
function  GetMaxX:Integer;
function  GetMaxY:Integer;
function  GetModeName(ModeNummer:integer):shortstring;
procedure GetModeRange(GDriver:Integer; var LoMode,HiMode:integer);
procedure GetPalette(var Palette:Palettetype);
function  GetPaletteSize:integer;
function  GetPixel(x,y:Integer):longint;
procedure GetTextSettings(var TextInfo:TextSettingsType);
procedure GetViewSettings(var ViewPort:ViewPortType);
function  GetX:integer;
function  GetY:integer;
procedure GraphDefaults;
function  GraphErrorMsg(ErrorCode:integer):shortstring;
function  GraphResult:Integer;
function  ImageSize(x1,y1,x2,y2:integer):word;
Procedure InitGraph(obj:TCanvas;mx,my:word);
function  InstallUserDriver(Name:shortstring; AutodetectPtr:Pointer):integer;
function  InstallUserFont(FontFileName:shortstring):Integer;
Procedure Line(x1,y1,x2,y2:integer);
procedure LineRel(dx,dy:integer);
procedure LineTo(x,y:integer);
procedure MoveRel(dx,dy:integer);
procedure MoveTo(x,y:integer);
procedure Outtext(Textstring:shortstring);
procedure OutTextXY(x,y:integer; Textstring:shortstring);
procedure PieSlice(x,y:Integer; StAngle,EndAngle,Radius:word);
procedure PutImage(x,y:Integer; var pBitMap; BitBlt:word);
procedure PutPixel(x,y:Integer; PixelColor:longint);
procedure Rectangle(x1,y1,x2,y2:integer);
function  RegisterBGIdriver(pDriver:Pointer):integer;
function  RegisterBGIfont(pFont:Pointer):integer;
procedure RestoreCRTmode;
procedure Sector(x,y:integer; StAngle,EndAngle,XRadius,YRadius:word);
procedure SetActivePage(Page:word);
procedure SetAllPalette(var Palette:PaletteType);
procedure SetAspectRatio(Xasp,Yasp:word);
procedure SetBkColor(ColorNum:byte);
procedure SetColor(ColorNum:byte);
procedure SetFillPattern(Pattern: FillPatternType; Color:longint);
procedure SetFillStyle(Pattern,Color:longint);
procedure SetGraphBufSize(BufSize:word);
procedure SetGraphMode(Mode:integer);
procedure SetLineStyle(LineStyle,Pattern,Thickness:word);
procedure SetPalette(ColorNum:word;Color:longint);
procedure SetRGBpalette(ColorNum:word;RedValue,GreenValue,BlueValue:byte);
procedure SetTextJustify(Horiz,Vert:word);
procedure SetTextStyle(Font,Direction,Charsize:word);
procedure SetUserCharSize(MultX,DivX,MultY,DivY:word);
procedure SetViewPort(x1,y1,x2,y2:integer;Clip:boolean);
procedure SetVisualPage(Page:word);
procedure SetWriteMode(WriteMode:integer);
function  TextHeight(TextString:shortstring):word;
function  TextWidth(TextString:shortstring):word;
implementation

Procedure InitGraph;
begin
 Maxx:=mx; Maxy:=my;
 FontNames[0]:='Default';
 FontNames[1]:='Arial';
 FontNames[2]:='MS Serif';
 FontNames[3]:='MS Sans Serif';
 FontNames[4]:='MS LineDraw';
 if not VGAactive then //MyScreen:=TCanvas.Create;
 MyScreen:=obj;
 VGAactive:=true;
 SetFillStyle(SolidFill,Black);
 SetTextStyle(1,0,8);
 with Myscreen do begin
  with PenPos do begin
  x:=0; y:=0;
  end;
  refresh;
 end;
 ClearDevice;
end;

procedure Arc(x,y:Integer;StAngle,EndAngle,Radius:word);
  procedure GetAx(winkel:word; var sina,cosa:real);
  var radw:real;
  begin
  radw:=winkel*pi/180;sina:=sin(radw); cosa:=cos(radw) ;
  end;
var sSin,sCos,eSin,eCos:real;
begin
  GetAx(StAngle,sSin,sCos);
  GetAx(EndAngle,eSin,eCos);
  Myscreen.Arc(x-radius,y-radius,x+radius,y+radius,
               x+round(sCos*radius),y-round(sSin*radius),
               x+round(eCos*radius),y-round(eSin*radius));
end;

procedure Circle(x,y:integer;Radius:word);
var tb:TBrush;
begin
 tb:=Myscreen.Brush;
 Myscreen.Brush.Style:=bsClear;
 Myscreen.Ellipse(x-radius,y-radius,x+radius,y+radius);
 Myscreen.Brush:=tb;
end;

Procedure Line;
begin
 with Myscreen do begin
  moveto(x1,y1);
  LineTo(x2,y2);
  //Repaint
 end
end;

procedure Bar(x1,y1,x2,y2:integer);
var r:TRect; i,j:word;
begin
 with r do begin Left:=x1; right:=x2+1; Top:=y1; Bottom:=y2+1 end;
 case vFillsettings.Pattern of
  WideDotFill:for i:=r.left to r.right do for j:=r.top to r.Bottom do
              if ((i mod 5)=0) and ((j mod 5)=0) then putpixel(i,j,vFillsettings.color);
  CloseDotFill:for i:=r.left to r.right do for j:=r.top to r.Bottom do
              if ((i mod 2)=0) and ((j mod 2)=0) then putpixel(i,j,vFillsettings.color);
  //UserFill:Style:=bs;
  else begin
   Myscreen.Brush.Color:=GetVGAColor(vFillSettings.Color);
   Myscreen.FillRect(r);
  end
 end;

end;

procedure ClearDevice;
var r:TRect;
begin
 r.Left:=0; r.Top:=0; r.Right:=MaxX+1; r.Bottom:=Maxy+1;
 with MyScreen do FillRect(r);
end;

procedure ClearViewPort;
var i:byte;
begin
 i:=0;
end;

procedure CloseGraph;
begin
 {if VGAactive then
 try
//  Myscreen.Free;
  Myscreen:=nil;
  Myscreen.Free;
 except
 end;}
 VGAactive:=false;
end;

procedure DetectGraph(var GDriver,GMode:Integer);
begin
 GDriver:=4; GMode:=2;
end;

procedure DrawPoly(NumPoints:word; var PolyPoints);
var i:byte;
begin
 i:=0;
end;

procedure Ellipse(x,y:integer; StAngle,EndAngle, XRadius,YRadius:word);
var tb:TBrush;
begin
 tb:=Myscreen.Brush;
 Myscreen.Brush.Style:=bsClear;
 MyScreen.Ellipse(x-XRadius,y-YRadius,x+XRadius,y+YRadius);
 Myscreen.Brush:=tb;
end;

procedure FillEllipse(x,y:integer; XRadius,YRadius:Word);
var tb:TBrush;
begin
 tb:=Myscreen.Brush;
 Myscreen.Brush.Style:=bsSolid;
 Myscreen.Brush.Color:=vFillSettings.Color;
 MyScreen.Ellipse(x-XRadius,y-YRadius,x+XRadius,y+YRadius);
 Myscreen.Brush:=tb;
end;

procedure FillPoly(NumPoints:Word; var PolyPoints);
var i:byte;
begin
 i:=0;
end;

procedure FloodFill(x,y:Integer; BorderColor:longint);
var i:byte;
begin
 MyScreen.FloodFill(x,y,BorderColor,fsborder);
end;

procedure GetArcCoords(var ArcCoords: ArcCoordsType);
var i:byte;
begin
 i:=0;
end;

procedure GetAspectRatio(var Xasp,Yasp:word);
var i:byte;
begin
 i:=0;
end;

function  GetBkColor:longint;
begin
 GetBkColor:=Myscreen.brush.Color;
end;

function  GetColor:longint;
begin
 GetColor:=Myscreen.pen.color;
end;

procedure GetDefaultpalette(var Palette:PaletteType);
var i:byte;
begin
 i:=0;
end;

function  GetDriverName:shortstring;
begin
 GetDriverName:='DelGraph';
end;

procedure GetFillPattern(var FillPattern:FillPatternType);
var i:byte;
begin
 i:=0;
end;

procedure GetFillSettings(var FillInfo:FillSettingsType);
begin
 with FillInfo do begin
 Pattern:=vFillSettings.Pattern;
 Color:=vFillSettings.Color;
 end
end;

function  GetGraphMode:Integer;
begin
 GetGraphMode:=VGAHi;
end;

procedure GetImage(x1,y1,x2,y2:Integer; var pBitMap);
var i:byte;
begin
 i:=0;
end;

procedure GetLineSettings(var LineInfo:LineSettingsType);
var i:byte;
begin
 i:=0;
end;

function  GetMaxColor:longint;
begin
 GetMaxColor:=maxint;
end;

function  GetMaxMode:Integer;
begin
 GetMaxMode:=1;
end;

function  GetMaxX:Integer;
begin
 GetMaxX:=MaxX;
end;

function  GetMaxY:Integer;
begin
 GetMaxY:=MaxY;
end;

function  GetModeName(ModeNummer:integer):shortstring;
begin
 GetModeName:='VGAHi';
end;

procedure GetModeRange(GDriver:Integer; var LoMode,HiMode:integer);
var i:byte;
begin
 i:=0;
end;

procedure GetPalette(var Palette:Palettetype);
var i:byte;
begin
 i:=0;
end;

function  GetPaletteSize:integer;
begin
 GetPaletteSize:=16;
end;

function  GetPixel(x,y:Integer):longint;
begin
 case GDriver of
  0..10: GetPixel:=GetEGAColor(MyScreen.Pixels[x,y]);
  else Getpixel:=Myscreen.Pixels[x,y];
 end;
end;

procedure GetTextSettings(var TextInfo:TextSettingsType);
var i:byte;
begin
 i:=0;
end;

procedure GetViewSettings(var ViewPort:ViewPortType);
var i:byte;
begin
 i:=0;
end;

function  GetX:integer;
begin
 GetX:=MyScreen.PenPos.x;
end;

function  GetY:integer;
begin
 GetY:=MyScreen.PenPos.y;
end;

procedure GraphDefaults;
var i:byte;
begin
 i:=0;
end;

function  GraphErrorMsg(ErrorCode:integer):shortstring;
begin
 GraphErrorMsg:='GraphError!';
end;

function  GraphResult:Integer;
begin
 GraphResult:=0;
end;

function  ImageSize(x1,y1,x2,y2:integer):word;
begin
 Imagesize:=0;
end;

function  InstallUserDriver(Name:shortstring; AutodetectPtr:Pointer):integer;
begin
 InstallUserDriver:=1;
end;

function  InstallUserFont(FontFileName:shortstring):Integer;
var i:byte;
begin
 for i:=0 to 5 do
  if FontNames[i]='' then begin
   Fontnames[i]:=FontFileName;
   break
 end;
 result:=i;
end;

procedure LineRel(dx,dy:integer);
begin
 with MyScreen do LineTo(PenPos.x+dx,PenPos.y+dy);
end;

procedure LineTo(x,y:integer);
begin
 with MyScreen do LineTo(x,y);
end;

procedure MoveRel(dx,dy:integer);
begin
 with MyScreen do MoveTo(PenPos.x+dx,PenPos.y+dy);
end;

procedure MoveTo(x,y:integer);
begin
 with MyScreen do MoveTo(x,y);
end;

procedure Outtext(Textstring:shortstring);
begin
 with MyScreen do begin
  Font.Color:=pen.Color;
  TextOut(PenPos.x,PenPos.y,Textstring);
 end;
end;

procedure OutTextXY(x,y:integer; Textstring:shortstring);
begin
 with MyScreen do begin
  Font.Color:=pen.Color;
  TextOut(x,y,Textstring);
 end;
end;

procedure PieSlice(x,y:Integer; StAngle,EndAngle,Radius:word);
var i:byte;
begin
 i:=0;
end;

procedure PutImage(x,y:Integer; var pBitMap; BitBlt:word);
var i:byte;
begin
 i:=0;
end;

procedure PutPixel(x,y:Integer; PixelColor:longint);
begin
 //if SetRGBPalette... then ..:=Pixelcolor else
 if GDriver in [0..10] then
 MyScreen.Pixels[x,y]:=getVGAcolor(PixelColor)
 else
 MyScreen.Pixels[x,y]:=PixelColor;
end;

procedure Rectangle(x1,y1,x2,y2:integer);
var i:TRect;
begin
 with i do begin Left:=x1; right:=x2; Top:=y1; Bottom:=y2 end;
 MyScreen.FrameRect(i);
end;

function  RegisterBGIdriver(pDriver:Pointer):integer;
begin
 RegisterBGIdriver:=0;
end;

function  RegisterBGIfont(pFont:Pointer):integer;
begin
 RegisterBGIfont:=0;
end;

procedure RestoreCRTmode;
var i:byte;
begin
 i:=0;
end;

procedure Sector(x,y:integer; StAngle,EndAngle,XRadius,YRadius:word);
var i:byte;
begin
 i:=0;
end;

procedure SetActivePage(Page:word);
var i:byte;
begin
 i:=0;
end;

procedure SetAllPalette(var Palette:PaletteType);
begin
 with Palette do begin
 Size:=16;
 Colors[00]:={    cblack       }$00000000;
 Colors[01]:={    cblue        }$00a80000;
 Colors[02]:={    cgreen       }$0000a800;
 Colors[03]:={    ccyan        }$00a8a800;
 Colors[04]:={    cred         }$000000a8;
 Colors[05]:={    cmagenta     }$00a800a8;
 Colors[06]:={    cbrown       }$000054fc;
 Colors[07]:={    clightgray   }$00a8a8a8;

 Colors[08]:={    cdarkgray    }$00545454;
 Colors[09]:={    clightblue   }$00fc5454;
 Colors[10]:={    clightgreen  }$0054fc54;
 Colors[11]:={    clightcyan   }$00fcfc54;
 Colors[12]:={    clightred    }$005454fc;
 Colors[13]:={    clightmagenta}$00fc54fc;
 Colors[14]:={    cyellow      }$0054fcfc;
 Colors[15]:={    cwhite       }$00FCFCFC;
 end;
end;

procedure SetAspectRatio(Xasp,Yasp:word);
var i:byte;
begin
 i:=0;
end;

function GetEGAColor(Pixel:longint):longint;
var i:longint;
begin
 case Pixel of
  black:i:=0;
  blue:i:=1;
  green:i:=2;
  cyan:i:=3;
  red:i:=4;
  Magenta:i:=5;
  brown:i:=6;
  lightgray:i:=7;
  darkgray:i:=8;
  lightblue:i:=9;
  lightgreen:i:=10;
  lightcyan:i:=11;
  lightred:i:=12;
  lightmagenta:i:=13;
  yellow:i:=14;
  white:i:=16;
  else i:=Pixel;
 end;
 GetEGAColor:=i;
end;

function GetVGAColor(EGACol:byte):longint;
{const //            00BBGGRR
     cblack       =$00000000;
     cblue        =$00a80000;
     cgreen       =$0000a800;
     ccyan        =$00a8a800;
     cred         =$000000a8;
     cmagenta     =$00a800a8;
     cbrown       =$000054fc;
     clightgray   =$00a8a8a8;

     cdarkgray    =$00545454;
     clightblue   =$00fc5454;
     clightgreen  =$0054fc54;
     clightcyan   =$00fcfc54;
     clightred    =$005454fc;
     clightmagenta=$00fc54fc;
     cyellow      =$0054fcfc;
     cwhite       =$00FCFCFC;

var i:longint;}
begin
{ case EGACol of
  0:i:=cblack;
  1:i:=cblue;
  2:i:=cgreen;
  3:i:=cCyan;
  4:i:=cred;
  5:i:=cMagenta;
  6:i:=cbrown;
  7:i:=clightgray;
  8:i:=cdarkgray;
  9:i:=clightblue;
 10:i:=clightgreen;
 11:i:=clightcyan;
 12:i:=clightred;
 13:i:=clightmagenta;
 14:i:=cyellow;
 15:i:=cwhite;
 else i:=cblack;
 end;}
 getVGAcolor:=ColorTable.Colors[EGACol];
end;

Procedure SetColor(ColorNum:byte);
begin
 Myscreen.Pen.Color:=GetVGAcolor(ColorNum);
end;

Procedure SetBkColor(ColorNum:byte);
begin
// Myscreen.Brush.Style:=bsSolid;
 Myscreen.Brush.Color:=GetVGAcolor(ColorNum);
end;

procedure SetFillPattern(Pattern: FillPatternType; Color:longint);
var i:byte;
begin
 i:=0;
end;

procedure SetFillStyle(Pattern,Color:longint);
begin
 with MyScreen.Brush do
 case pattern of
  EmptyFill:     Style:=bsClear;
  SolidFill:     Style:=bsSolid;
  LineFill:      Style:=bsHorizontal;
  LtSlashFill:   Style:=bsBDiagonal;
  SlashFill:     Style:=bsBDiagonal;
  BKSlashFill:   Style:=bsFDiagonal;
  LtBkSlashFill: Style:=bsFDiagonal;
  HatchFill:     Style:=bsCross;
  XHatchFill:    Style:=bsDiagCross;
  InterleaveFill:Style:=bsVertical;
  else
   Style:=bsSolid;
{  WideDotFill:Style:=bs?;
  CloseDotFill:Style:=bs?;
  UserFill:Style:=bs?;}
 end;
 MyScreen.brush.Color:=GetVGAColor(Color);
 vFillSettings.Pattern:=Pattern;
 vFillSettings.Color:=GetVGAColor(Color);
end;

procedure SetGraphBufSize(BufSize:word);
var i:byte;
begin
 i:=0;
end;

procedure SetGraphMode(Mode:integer);
var i:byte;
begin
 i:=0;
end;

procedure SetLineStyle(LineStyle,Pattern,Thickness:word);
var i:byte;
begin
 i:=0;
 MyScreen.Pen.Style:=TPenStyle(LineStyle);
 if Pattern=0 then
 MyScreen.pen.Mode:=pmCopy else
 MyScreen.pen.Mode:=TPenMode(Pattern);
 MyScreen.Pen.Width:=Thickness;
end;

procedure SetPalette(ColorNum:word;Color:longint);
begin
 ColorTable.Colors[ColorNum]:=Palette.Colors[Color];
end;

procedure SetRGBpalette(ColorNum:word;RedValue,GreenValue,BlueValue:byte);
begin
 ColorTable.Colors[ColorNum]:=BlueValue*65535+GreenValue*256+RedValue;
end;

procedure SetTextJustify(Horiz,Vert:word);
var i:byte;
begin
 i:=0;
end;

procedure SetTextStyle(Font,Direction,Charsize:word);
begin
 with Myscreen.Font do begin
  Charset:=UserCharSet;
  Name:=FontNames[Font];
  if CharSize=0 then CharSize:=8;
  Size:=CharSize;
 end;
end;

procedure SetUserCharSize(MultX,DivX,MultY,DivY:word);
var i:byte;
begin
 i:=0;
end;

procedure SetViewPort(x1,y1,x2,y2:integer;Clip:boolean);
var i:byte;
begin
 i:=0;
end;

procedure SetVisualPage(Page:word);
var i:byte;
begin
 i:=0;
end;

procedure SetWriteMode(WriteMode:integer);
var i:byte;
begin
 i:=0;
end;

function  TextHeight(TextString:shortstring):word;
begin
 TextHeight:=MyScreen.TextHeight(TextString);
end;

function  TextWidth(TextString:shortstring):word;
begin
 TextWidth:=MyScreen.TextWidth(TextString);
end;

initialization
SetAllPalette(ColorTable);
SetAllPalette(Palette);
end.
